package refactor;

import mixin.AstNode;
import mixin.QName;




/**
 * Zugriff auf eine Variable.
 * 
 * @layer<typesys>
 * @author Stephan Klapproth
 */
abstract class FieldAccess$$typesys implements Declaration, AstElement {

    private Scope accessFrom;

    private FieldInfo field;
    
    private QName node;

    /**
     * Konstruktor.
     * 
     * @param aField
     *            das Attribut, auf das zugegriffen wird.
     */
    public FieldAccess$$typesys(FieldInfo aField, QName aNode) {
        field = aField;
        node = aNode;
    }
    
    public boolean isAttribute() {
        return field instanceof ClassInfo;
    }

    /**
     * Gibt das Objektattribut zurck.
     * 
     * @return das Objektattribut, auf das zugegriffen wird.
     */
    public FieldInfo getField() {
        return field;
    }

    public Scope getContext() {
        return accessFrom;
    }

    public void setContext(Scope aScope) {
        accessFrom = aScope;
    }

    public String getFullName() {
        return getName();
    }

    public String getName() {
        return field.getName();
    }

    public int endLineNum() {
        return node.findToken().lineNum();
    }

    public AstNode getAstNode() {
        return node;
    }

    public int startLineNum() {
        return node.findToken().lineNum();
    }
}




/**
 * @layer<refactoring_extrstmts>
 * @author Stephan Klapproth
 * 
 */
 class FieldAccess extends  FieldAccess$$typesys  {
    
    void addQName(String aQName) {
        RefUtil.addQNameBefore(aQName, (QName) getAstNode());
    }
      // inherited constructors



    /**
     * Konstruktor.
     * 
     * @param aField
     *            das Attribut, auf das zugegriffen wird.
     */
    public FieldAccess ( FieldInfo aField, QName aNode ) { super(aField, aNode); }

}
