package refactor;

import mixin.AstNode;
import mixin.IfStmt;
import mixin.ElseClauseC;




/**
 * 
 * @layer<typesys>
 * @author Stephan Klapproth
 * 
 */
class IfScope extends AbstractBlockScope {

    private IfStmt node;

    IfScope(IfStmt aNode) {
        node = aNode;
    }
    
    void init() {
        super.init();
        initExpression(node.getExpression());
        initStatement(node.getStatement());
        initElse();
    }

    private void initElse() {
        if (node.getElseClause() instanceof ElseClauseC) {
            initStatement(((ElseClauseC) node.getElseClause()).getStatement());
        }
    }

    public AstNode getAstNode() {
        return node;
    }
}
